//
// Copyright (C) 2005 Andras Varga
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
//


#ifndef __INET_TDELAY_H
#define __INET_TDELAY_H

#include <omnetpp.h>
#include "INETDefs.h"
//#include "INETDefsb.h"



/**
 * Measures and records network thruput
 */
// FIXME problem: if traffic suddenly stops, it'll show the last reading forever;
// (output vector will be correct though); would need a timer to handle this situation
class  INET_API Tdelay : public cSimpleModule
{
  protected:
    // config
    simtime_t startTime; // start time
    unsigned int batchSize;   // number of packets in a batch
    simtime_t maxInterval; // max length of measurement interval (measurement ends
                     // if either batchSize or maxInterval is reached, whichever
                     // is reached first)

    // global statistics
    unsigned long numPackets;
    unsigned long numBits;
    int emisor;
    // current measurement interval
    simtime_t intvlStartTime;
    simtime_t intvlLastPkTime;
    unsigned long intvlNumPackets;
    unsigned long intvlNumBits;
    long seqnum;
    long expectedReplySeqNo;
    long outoftimeReplySeqNo;
    long outOfOrderArrivalCount;
    int tempexpired;
    cMessage *timeoutEvent;

    simtime_t eej;
    // statistics
    cOutVector bitpersecVector;
    cOutVector pkpersecVector;
    cOutVector pkDelayVector;
    cOutVector JitterVector;
    cStdDev pkDelayStats;
    cStdDev pkJitter;
    cStdDev pkJitter2;

  protected:
    virtual void updateStats(simtime_t now, unsigned long bits);
    virtual void beginNewInterval(simtime_t now);
    void RecordDelay(Valores *nuevo);

  protected:
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    virtual void finish();
};

#endif

